> ## Documentation Index
> Fetch the complete documentation index at: https://developers.telnyx.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Find webhook_delivery details by ID

> Provides webhook_delivery debug data, such as timestamps, delivery status and attempts.



## OpenAPI

````yaml https://telnyx-openapi-ng.s3.us-east-1.amazonaws.com/account-billing/webhooks.yml get /webhook_deliveries/{id}
openapi: 3.1.0
info:
  title: Telnyx Webhooks API
  version: 2.0.0
  description: API for Webhooks.
  contact:
    email: support@telnyx.com
servers:
  - url: https://api.telnyx.com/v2
security:
  - bearerAuth: []
paths:
  /webhook_deliveries/{id}:
    get:
      tags:
        - Webhooks
      summary: Find webhook_delivery details by ID
      description: >-
        Provides webhook_delivery debug data, such as timestamps, delivery
        status and attempts.
      operationId: GetWebhookDelivery
      parameters:
        - name: id
          in: path
          required: true
          description: Uniquely identifies the webhook_delivery.
          schema:
            type: string
            format: uuid
            example: C9C0797E-901D-4349-A33C-C2C8F31A92C2
      responses:
        '200':
          description: Webhook delivery record.
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    $ref: '#/components/schemas/webhook_delivery'
        '401':
          description: Unauthorized
        '404':
          description: WebhookDelivery not found
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Telnyx from 'telnyx';

            const client = new Telnyx({
              apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
            });

            const webhookDelivery = await client.webhookDeliveries.retrieve(
              'C9C0797E-901D-4349-A33C-C2C8F31A92C2',
            );

            console.log(webhookDelivery.data);
        - lang: Python
          source: |-
            import os
            from telnyx import Telnyx

            client = Telnyx(
                api_key=os.environ.get("TELNYX_API_KEY"),  # This is the default and can be omitted
            )
            webhook_delivery = client.webhook_deliveries.retrieve(
                "C9C0797E-901D-4349-A33C-C2C8F31A92C2",
            )
            print(webhook_delivery.data)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/team-telnyx/telnyx-go\"\n\t\"github.com/team-telnyx/telnyx-go/option\"\n)\n\nfunc main() {\n\tclient := telnyx.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\twebhookDelivery, err := client.WebhookDeliveries.Get(context.TODO(), \"C9C0797E-901D-4349-A33C-C2C8F31A92C2\")\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", webhookDelivery.Data)\n}\n"
        - lang: Java
          source: >-
            package com.telnyx.sdk.example;


            import com.telnyx.sdk.client.TelnyxClient;

            import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;

            import
            com.telnyx.sdk.models.webhookdeliveries.WebhookDeliveryRetrieveParams;

            import
            com.telnyx.sdk.models.webhookdeliveries.WebhookDeliveryRetrieveResponse;


            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    TelnyxClient client = TelnyxOkHttpClient.fromEnv();

                    WebhookDeliveryRetrieveResponse webhookDelivery = client.webhookDeliveries().retrieve("C9C0797E-901D-4349-A33C-C2C8F31A92C2");
                }
            }
        - lang: Ruby
          source: >-
            require "telnyx"


            telnyx = Telnyx::Client.new(api_key: "My API Key")


            webhook_delivery =
            telnyx.webhook_deliveries.retrieve("C9C0797E-901D-4349-A33C-C2C8F31A92C2")


            puts(webhook_delivery)
        - lang: PHP
          source: >-
            <?php


            require_once dirname(__DIR__) . '/vendor/autoload.php';


            use Telnyx\Client;

            use Telnyx\Core\Exceptions\APIException;


            $client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API
            Key');


            try {
              $webhookDelivery = $client->webhookDeliveries->retrieve(
                'C9C0797E-901D-4349-A33C-C2C8F31A92C2'
              );

              var_dump($webhookDelivery);
            } catch (APIException $e) {
              echo $e->getMessage();
            }
        - lang: CLI
          source: |-
            telnyx webhook-deliveries retrieve \
              --api-key 'My API Key' \
              --id C9C0797E-901D-4349-A33C-C2C8F31A92C2
components:
  schemas:
    webhook_delivery:
      description: Record of all attempts to deliver a webhook.
      properties:
        id:
          description: Uniquely identifies the webhook_delivery record.
          type: string
          format: uuid
          example: f5586561-8ff0-4291-a0ac-84fe544797bd
        user_id:
          description: Uniquely identifies the user that owns the webhook_delivery record.
          type: string
          format: uuid
          example: 0ccc7b54-4df3-4bca-a65a-3da1ecc777f0
        record_type:
          description: Identifies the type of the resource.
          type: string
          example: webhook_delivery
        status:
          description: >-
            Delivery status: 'delivered' when successfuly delivered or 'failed'
            if all attempts have failed.
          enum:
            - delivered
            - failed
          type: string
        webhook:
          description: >-
            Original webhook JSON data. Payload fields vary according to event
            type.
          type: object
          properties:
            record_type:
              type: string
              example: event
              enum:
                - event
              description: Identifies the type of the resource.
            event_type:
              type: string
              example: webhook.command
              description: The type of event being delivered.
            id:
              type: string
              format: uuid
              example: 0ccc7b54-4df3-4bca-a65a-3da1ecc777f0
              description: Identifies the type of resource.
            occurred_at:
              type: string
              format: date-time
              example: '2018-02-02T22:25:27.521992Z'
              description: ISO 8601 datetime of when the event occurred.
            payload:
              type: object
              additionalProperties: true
          example:
            record_type: event
            id: C9C0797E-901D-4349-A33C-C2C8F31A92C2
            event_type: call_initiated
            occurred_at: '2020-08-10T13:02:01.000Z'
            payload:
              useful: information
        started_at:
          description: >-
            ISO 8601 timestamp indicating when the first request attempt was
            initiated.
          type: string
          format: date-time
          example: '2020-08-10T14:00:00.000Z'
        finished_at:
          description: >-
            ISO 8601 timestamp indicating when the last webhook response has
            been received.
          type: string
          format: date-time
          example: '2020-08-10T14:00:05.595Z'
        attempts:
          description: Detailed delivery attempts, ordered by most recent.
          type: array
          items:
            $ref: '#/components/schemas/attempt'
          example:
            - status: delivered
              started_at: '2020-08-10T14:00:05.364Z'
              finished_at: '2020-08-10T14:00:05.595Z'
              http:
                request:
                  url: https://fallback.example.com/webhooks
                  headers:
                    - - Accept
                      - '*/*'
                response:
                  status: 200
                  headers:
                    - - Content-Type
                      - text/html
                  body: All good.
            - status: failed
              started_at: '2020-08-10T14:00:05.004Z'
              finished_at: '2020-08-10T14:00:05.360Z'
              http:
                request:
                  url: https://typo.example.com/webhooks
                  headers:
                    - - Accept
                      - '*/*'
                response:
                  status: 404
                  headers:
                    - - Content-Type
                      - text/html
                    - - Pragma
                      - no-cache
                  body: Oops. Not found.
              errors:
                - 75499
    attempt:
      description: Webhook delivery attempt details.
      properties:
        status:
          type: string
          enum:
            - delivered
            - failed
        started_at:
          description: ISO 8601 timestamp indicating when the attempt was initiated.
          type: string
          format: date-time
        finished_at:
          description: ISO 8601 timestamp indicating when the attempt has finished.
          type: string
          format: date-time
        http:
          $ref: '#/components/schemas/http'
        errors:
          description: Webhook delivery error codes.
          type: array
          items:
            type: integer
      example:
        - status: delivered
          started_at: '2020-08-10T14:00:05.364Z'
          finished_at: '2020-08-10T14:00:05.595Z'
          http:
            request:
              url: https://fallback.example.com/webhooks
              headers:
                - - Accept
                  - '*/*'
            response:
              status: 200
              headers:
                - - Content-Type
                  - text/html
              body: All good.
        - status: failed
          started_at: '2020-08-10T14:00:05.004Z'
          finished_at: '2020-08-10T14:00:05.360Z'
          http:
            request:
              url: https://typo.example.com/webhooks
              headers:
                - - Accept
                  - '*/*'
            response:
              status: 404
              headers:
                - - Content-Type
                  - text/html
                - - Pragma
                  - no-cache
              body: Oops. Not found.
          errors:
            - 75499
        - status: failed
          started_at: '2020-08-10T14:00:00.000Z'
          finished_at: '2020-08-10T14:00:05.000Z'
          http:
            request:
              url: https://slow.example.com/webhooks
              headers:
                - 'Accept: */*'
            reponse: null
          errors:
            - code: '75001'
              title: Could not resolve name
              detail: Unable to resolve the webhook URL domain name
    http:
      description: HTTP request and response information.
      properties:
        request:
          description: Request details.
          properties:
            url:
              type: string
              example: https://example.com/webhooks
            headers:
              $ref: '#/components/schemas/http_headers'
        response:
          description: Response details, optional.
          type: object
          properties:
            status:
              type: integer
              example: 200
            headers:
              $ref: '#/components/schemas/http_headers'
            body:
              description: Raw response body, limited to 10kB.
              type: string
    http_headers:
      description: List of headers, limited to 10kB.
      type: array
      example:
        - - header_name
          - header_value
      items:
        type: array
        items:
          type: string
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````